///home/berryj/link/bin/genMethods "-g" "-t" "Set<Vertex*>" "-h" "MSet" "-r" "Collection<Set<Vertex*> >" "-I" "LINK/graph/Vertex.h" "-I" "LINK/basic/Set.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Vertex.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Set<Vertex*> _Set_Vertex__;
typedef MSet<Set<Vertex*> > _MSet_Set_Vertex___;
static MSet<Set<Vertex*> > s__MSet_Set_Vertex___;

#define _MSet_Set_Vertex___DATA(x) ((MSet<Set<Vertex*> >*) (EXTDATA(x)))
#define _MSet_Set_Vertex___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Set<Vertex*> > >::type))
#define _MSet_Set_Vertex___ISNT_DATA(x) (!_MSet_Set_Vertex___IS_DATA(x))

#define _MSet_Set_Vertex___CXX_DATA(x) (*(MSet<Set<Vertex*> >*) (EXTDATA(VAL(x))))
#define _MSet_Set_Vertex___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Set<Vertex*> > >::type))
#define _MSet_Set_Vertex___CXX_ISNT_DATA(x) (!_MSet_Set_Vertex___CXX_IS_DATA(x))


PRIMITIVE STk_init__MSet_Set_Vertex___()
{
	Wrapper<_MSet_Set_Vertex___>::type = STk_new_CXXwrapper_id(
			Wrapper<_MSet_Set_Vertex___>::name, 
			Wrapper<Collection<Set<Vertex*> > >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Set_Vertex__>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Vertex__>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Vertex__>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_MSet_Set_Vertex___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_MSet_Set_Vertex___Methods(void);

PRIMITIVE STk_init_methods__MSet_Set_Vertex___()
{
	genExtra_MSet_Set_Vertex___Methods();
	return UNDEFINED;
}
